From 1ca4e4c5ef7feb7ef971dd15211434f04719af72 Mon Sep 17 00:00:00 2001
From: Sebastian Poeplau <sebastian.poeplau@eurecom.fr>
Date: Tue, 26 Mar 2019 17:37:30 +0100
Subject: [PATCH] Measure the time spent on symbolic execution

---
 angr/engines/vex/engine.py | 6 ++++++
 1 file changed, 6 insertions(+)

diff --git a/angr/engines/vex/engine.py b/angr/engines/vex/engine.py
index 743731b0..9e05bfa7 100644
--- a/angr/engines/vex/engine.py
+++ b/angr/engines/vex/engine.py
@@ -1,4 +1,5 @@
 import sys
+import time
 from cachetools import LRUCache
 
 import pyvex
@@ -18,6 +19,8 @@ from .expressions import translate_expr
 import logging
 l = logging.getLogger("angr.engines.vex.engine")
 
+symbolic_time = 0
+
 #pylint: disable=arguments-differ
 
 VEX_IRSB_MAX_SIZE = 400
@@ -138,6 +141,7 @@ class SimEngineVEX(SimEngine):
         return True
 
     def _process(self, state, successors, irsb=None, skip_stmts=0, last_stmt=99999999, whitelist=None, insn_bytes=None, size=None, num_inst=None, traceflags=0, thumb=False, opt_level=None):
+        start_time = time.time()
         successors.sort = 'IRSB'
         successors.description = 'IRSB'
         state.history.recent_block_count = 1
@@ -206,6 +210,8 @@ class SimEngineVEX(SimEngine):
         state._inspect('irsb', BP_AFTER, address=addr)
 
         successors.processed = True
+        global symbolic_time
+        symbolic_time += time.time() - start_time
 
     def _handle_irsb(self, state, successors, irsb, skip_stmts, last_stmt, whitelist):
         # shortcut. we'll be typing this a lot
-- 
2.23.0

